struct s
(
	tTooltip = "Sets all material id channels in the scene to 0.",
	
	fn count =
	(
		local lMatIds = #()
		
		for mat in scenematerials do
		(
			try
			(
				if classof mat == multimaterial
					then for subMat in mat.materialList where subMat.effectsChannel != 0 do appendIfUnique lMatIds subMat.effectsChannel 
					else if mat.effectsChannel != 0 then appendIfUnique lMatIds mat.effectsChannel
			)
			catch ()
		)
		
		return lMatIds.count
	),
	
	fn clean =
	(
		for mat in scenematerials do
		(
			try
			(
				if classof mat == multimaterial
					then for subMat in mat.materialList where subMat.effectsChannel != 0 do subMat.effectsChannel = 0
					else if mat.effectsChannel != 0 then mat.effectsChannel = 0
			)
			catch ()
		)
	),
	
	fn selectObjects =
	(
		local lMats = #()
		
		for mat in scenematerials do
		(
			try
			(
				if classof mat == multimaterial
					then for subMat in mat.materialList where subMat.effectsChannel != 0 do appendIfUnique lMats subMat
					else if mat.effectsChannel != 0 then appendIfUnique lMats mat
			)
			catch ()
		)
		
		local lObjs = #()
		for mat in lMats do for obj in (refs.dependents mat) where classof (superclassof obj) == node and (obj as string)[1] == "$" do appendIfUnique lObjs obj
		
		select lObjs
		
		local bRefreshSel = false
		for obj in selection do
		(
			if isGroupHead obj and not isOpenGroupHead obj then
			(
				bRefreshSel = true
				setGroupOpen obj true
			)
		)
		if bRefreshSel then select lObjs
	),
	
	fn selectMaterials =
	(
		local lMats = #()
		
		for mat in scenematerials do
		(
			try
			(
				if classof mat == multimaterial
					then for subMat in mat.materialList where subMat.effectsChannel != 0 do appendIfUnique lMats subMat
					else if mat.effectsChannel != 0 then appendIfUnique lMats mat
			)
			catch ()
		)
		
		for nMat = 1 to lMats.count where nMat <= meditMaterials.count do setMeditMaterial nMat lMats[nMat]
	)
)
