struct s
(
	tTooltip = "Always useful to have the option 'straighten corners' enabled in shell-modifiers to avoid skewed edges.",
	
	fn count =
	(
		local nCount = 0
		
		for modObj in getclassinstances shell where not modObj.straightenCorners do nCount += 1
		
		nCount
	),
	
	fn clean =
	(
		for modObj in getclassinstances shell where not modObj.straightenCorners do modObj.straightenCorners = true
	),
	
	fn selectObjects =
	(
		local lmodInst = getclassinstances shell
		
		local lObjs = #()
		for modObj in lmodInst do for obj in (refs.dependents modObj) where classof (superclassof obj) == node do appendIfUnique lObjs obj
		
		select lObjs
		
		local bRefreshSel = false
		for obj in selection do
		(
			if isGroupHead obj and not isOpenGroupHead obj then
			(
				bRefreshSel = true
				setGroupOpen obj true
			)
		)
		if bRefreshSel then select lObjs
	)
)