struct s
(
	tTooltip = "Cleans Thinking Particles TP Variation Texmap in ColorCorrects, Vray-Materials and Multisubmaterials.",
	
	
	fn enabled =
	(
		berconnoise != undefined
	),

	fn count =
	(
		if berconnoise != undefined
			then (getclassinstances berconnoise).count
			else "-"
	),
	
	fn clean =
	(
		if berconnoise != undefined then 
		(
			local lMaps = makeUniqueArray (getclassinstances berconnoise)
			
			for map in lMaps do
			(
				local lDeps = refs.dependents map
				local parent = lDeps[1]
				local replaceMap = noise \
					color1:map.color1 \
					color2:map.color2 \
					map1:map.map1 \
					map2:map.map2 \
					map1Enabled:map.map1Enabled \
					map2Enabled:map.map2Enabled \
					size:map.size \
					phase:map.phase \
					levels:map.levels \
					thresholdLow:map.thresholdLow \
					thresholdHigh:map.thresholdHigh \
					coords:map.coords \
					output:map.output
				
				if map.fractalType <= 2 then replaceMap.type = map.fractalType
				
				case classof parent of
				(
					ColorCorrect: parent.src_tex = replaceMap
					VrayMtl: parent.texmap_diffuse = replaceMap
					Standardmaterial: parent.diffuseMap = replaceMap
				)
			)
		)
	),
	
	fn selectObjects =
	(
		if berconnoise != undefined then 
		(
			local lObjs = #()
			for mat in (getclassinstances berconnoise) do
			(
				for obj in (refs.dependents mat) where classof (superclassof obj) == node do appendIfUnique lObjs obj
			)
			
			select lObjs
			local bRefreshSel = false
			for obj in selection do
			(
				if isGroupHead obj and not isOpenGroupHead obj then
				(
					bRefreshSel = true
					setGroupOpen obj true
				)
			)
			if bRefreshSel then select lObjs
		)
	),
	
	fn selectMaterials =
	(
		if berconnoise != undefined then 
		(
			local lMats = #()
			
			for mat in (getclassinstances berconnoise) do appendIfUnique lMats mat
			
			for nMat = 1 to lMats.count where nMat <= meditMaterials.count do setMeditMaterial nMat lMats[nMat]
		)
	)
)
