struct s
(
	tTooltip = "IES Scale must be positive, or their normal is flipped and they point upwards.",
	
	fn enabled =
	(
		vray != undefined
	),

	fn count =
	(
		local nCount = 0
		
		for iesLight in lights where classof iesLight == VRayIES do
		(
			if iesLight.transform[3].z < 0 and iesLight.center.z > iesLight.target.pos.z then nCount += 1
		)
		
		nCount
	),
	
	fn clean =
	(
		for iesLight in lights where classof iesLight == VRayIES do
		(
			if iesLight.transform[3].z < 0 and iesLight.center.z > iesLight.target.pos.z then
			(
				-- unlink
				local lChilds = for child in iesLight.children collect child
				local parent = iesLight.parent
				for child in lChilds do child.parent = undefined
				iesLight.parent = undefined
				
				iesLight.scale = [1,1,1]
				
				-- relink
				for child in lChilds do child.parent = iesLight
				iesLight.parent = parent
			)
		)
	)
)