struct s
(
	tTooltip = "Lightmaterials must be in VrayWrapperMaterials with Generate GI off, otherwise can cause problems with Xrefs.",
	
	fn enabled =
	(
		vray != undefined
	),

	fn count =
	(
		local nCount = 0
		
		local lLightMat = getclassinstances vraylightmtl
		local lWrapperMat = getclassinstances vraymtlwrapper
		local lMultiMat = getclassinstances multimaterial
		
		for lightMat in lLightMat do
		(
			local wrapperMat = undefined
			for mat in lWrapperMat where mat.baseMtl == lightMat do wrapperMat = mat
			
			if wrapperMat == undefined or wrapperMat.generateGI then
			(
				nCount += 1
			)
		)
		
		nCount
	),

	fn clean =
	(
		local lLightMat = getclassinstances vraylightmtl
		local lWrapperMat = getclassinstances vraymtlwrapper
		local lMultiMat = getclassinstances multimaterial
		
		for lightMat in lLightMat do
		(
			local wrapperMtl = vraymtlwrapper generateGI:false basemtl:lightMat
			
			for mat in lWrapperMat where mat.baseMtl == lightMat do
			(
				mat.generateGI == false
				print mat.generateGI
			)
			
			for mat in lMultiMat do for n=1 to mat.materialList.count where mat.materialList[n] == lightMat do
			(
				mat.materialList[n] = wrapperMtl
			)
			
			for obj in objects where obj.mat == lightMat do obj.mat = wrapperMtl
		)
	),
	
	fn selectObjects =
	(
		local lLightMat = getclassinstances vraylightmtl
		local lObjs = #()
		
		for lightMat in lLightMat do
		(
			local bUsedInScene = false
			for ref in refs.dependents lightMat do
			(
				if classof (superclassof ref) == node then append lObjs ref
			)
		)
		
		select lObjs
	)
)
