(
	--clearListener()
	
	local bStartup = try cCleaner.bStartup and cCleaner.open catch false
	
	if bStartup then print "Cleaner already running!"
	else
	(
		try cCleaner.closeDialog() catch()
		
		global cCleaner = rollout cCleaner ""
		(
			-- VARS
				
				local tScriptDir = getfilenamepath (getThisScriptFilename())
				local tScriptTitle = "Cleaner v25 by Andreas Meissner"
				local tTaskDir = tScriptDir +"clean/"
				local tTempDir = tScriptDir +"Temp/"
				local tSettingsFile = tScriptDir +"Settings.txt"
				local lTasks
				local nWidth = 385
				local nPadd = 4
				local nGroupTaskOffsetY = 10
				local lCleanFunctions
				local lCountFunctions
				local lSelectObjectsFunctions
				local lCountButtons
				local CountThread
				local bStartup = true
				local colorClass = dotnetclass "system.drawing.color"
			
			-- CONTROLS
				
				--dotNetControl cCountLab "Label" text:"  count" height:20 width:185 pos:[0,0]
				label cHeadlineLab "                        clean                           |        count        |        select/get" pos:[5,5]
				dotNetControl cPanel "Panel" height:450 width:(nWidth-2*nPadd) pos:[nPadd,nPadd+15]
			
			-- FUNCTIONS
				
				fn removeSpecialChars t tAllow:"" =
				(
					local t2 = ""
					for n=1 to t.count where findString ("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"+ tAllow) t[n] != undefined do t2 += t[n]
					return t2
				)
				
				fn closeDialog =
				(
					destroyDialog cCleaner
					cCleaner = undefined
				)
				
				fn openDialog = 
				(
					print "Starting Cleaner ..."
					
					createDialog cCleaner style:#(#style_titlebar, #style_minimizebox, #style_border, #style_sysmenu, #style_resizing) lockWidth:true width:nWidth pos:[-9000,-9000]
					
					-- labels
						
						local n1 = 200
						--cCountLab.backcolor = colorClass.FromArgb n1 n1 n1
						--cCountLab.borderstyle = cCountLab.borderstyle.fixedsingle
					
					-- load tasks
						
						lTasks = #()
						local lTaskFiles = getFiles (tTaskDir +"*.ms")
						sort lTaskFiles
						for tFile in lTaskFiles do
						(
							try
							(
								struct tempStruct
								(
									tGroup,
									tName,
									tTooltip,
									enabled,
									count,
									clean,
									selectObjects,
									selectMaterials
								)
								
								local taskStruct = (fileIn tFile)()
								local tempStruct = tempStruct()
								local lFile = filterstring (getfilenamefile tFile) "-"
								local tTaskName = ""
								for n=2 to lFile.count do tTaskName += (if n == 2 then "" else "-") + lFile[n]
								
								tempStruct.tGroup = trimright lFile[1]
								tempStruct.tName = trimleft tTaskName
								if isproperty taskStruct "tName" then tempStruct.tName = taskStruct.tName
								tempStruct.tTooltip = taskStruct.tTooltip
								tempStruct.enabled = try taskStruct.enabled() catch true
								tempStruct.count = taskStruct.count
								tempStruct.clean = taskStruct.clean
								tempStruct.selectObjects = try taskStruct.selectObjects catch undefined
								tempStruct.selectMaterials = try taskStruct.selectMaterials catch undefined
								
								append lTasks tempStruct
							)
							catch
							(
								print ("could not load taskfile \""+ tFile +"\". "+ getcurrentexception())
							)
						)
					
					-- add controls
						
						cPanel.autoscroll = true
						
						lCleanFunctions = #()
						lCountFunctions = #()
						lCountButtons = #()
						lSelectObjectsFunctions = #()
						
						local lGroups = makeuniquearray (for task in lTasks collect task.tGroup)
						local lControls = #()
						local nScrollbarW = (dotnetclass "System.Windows.Forms.SystemInformation").VerticalScrollBarWidth
						local nControl = 0
						local nGroupTask = 0
						local nGroupControl = 0
						local nMaxY
						local nGroup
						local cGroup 
						local nButtonW = 0
						for task in lTasks do
						(
							local graphics = (dotNetObject "Button").creategraphics()
							local n = (graphics.measureString task.tName (dotNetObject "Button").font).width
							if n > nButtonW then nButtonW = n
						)
						nButtonW += 10
						
						for nTask=1 to lTasks.count do
						(
							local task = lTasks[nTask]
							nGroup = finditem lGroups task.tGroup
							nGroupTask += 1
							
							-- new groupbox
								
								if nTask == 1 or (nTask > 1 and nGroup != finditem lGroups lTasks[nTask-1].tGroup) then
								(
									cGroup = dotNetObject "GroupBox"
									nGroupTask = 1
									nGroupControl = 1
								)
							
							-- clean
								
								nGroupControl += 1
								nControl += 1
								
								local cClean = dotNetObject "Button"
								this = cClean
								this.text = task.tName
								this.name = "clean|"+ nTask as string
								this.enabled = false --task.enabled
								this.width = nButtonW
								this.location = dotnetobject "system.drawing.point" 4 ((nGroupTask-1)*25+20+nGroupTaskOffsetY)
								cGroup.controls.add cClean
							
							-- count
								
								nGroupControl += 1
								nControl += 1
								
								local cCount = dotNetObject "Button"
								this = cCount
								this.text = ""
								this.name = "count|"+ nTask as string
								this.enabled = false --task.enabled
								this.autosize = false
								this.textalign = this.textalign.middlecenter
								this.width = 60
								this.location = dotnetobject "system.drawing.point" (nButtonW+20) cClean.location.y
								cGroup.controls.add cCount
							
							-- select objects
								
								if task.selectObjects != undefined then
								(
									nGroupControl += 1
									nControl += 1
									
									local cSelObjs = dotNetObject "Button"
									this = cSelObjs
									this.text = "Objs"
									this.name = "select objects|"+ nTask as string
									this.enabled = false --task.enabled
									this.width = 40
									this.location = dotnetobject "system.drawing.point" (nButtonW+95) cClean.location.y
									cGroup.controls.add cSelObjs
								)
							
							-- select materials
								
								if task.selectMaterials != undefined then
								(
									nGroupControl += 1
									nControl += 1
									
									local cSelMats = dotNetObject "Button"
									this = cSelMats
									this.text = "Mats"
									this.name = "select materials|"+ nTask as string
									this.enabled = false --task.enabled
									this.width = 40
									this.location = dotnetobject "system.drawing.point" (nButtonW+140) cClean.location.y
									cGroup.controls.add cSelMats
								)
							
							-- groupbox
								
								if nTask == lTasks.count or (nTask < lTasks.count and nGroup != finditem lGroups lTasks[nTask+1].tGroup) then
								(
									nControl += 1
									
									nMaxY = 0
									for nItem=0 to cGroup.controls.count-1 do
									(
										local nNewMaxY = cGroup.controls.item[nItem].location.y + cGroup.controls.item[nItem].height + 12
										if nNewMaxY > nMaxY do nMaxY = nNewMaxY
									)
										
									cGroup.text = task.tGroup
									cGroup.size = dotnetobject "system.drawing.size" (nWidth-2*nPadd-nScrollbarW) (nMaxY)
									cGroup.margin =  dotnetobject "Padding" 2
									if nGroup == 1
										then cGroup.location = dotnetobject "system.drawing.point" 0 0
										else cGroup.location = dotnetobject "system.drawing.point" 0 (lControls[nGroup-1].location.y+lControls[nGroup-1].height)
									append lControls cGroup
								)
						)
						
						cPanel.controls.addRange lControls
					
					-- add eventhandler
						
						for nGroup=1 to cPanel.controls.count do
						(
							local cGroup = cPanel.controls.item (nGroup-1)
							for nGroupControl=1 to cGroup.controls.count do
							(
								local c = cGroup.controls.item (nGroupControl-1)
								local tAction = (filterstring c.name "|")[1]
								local nTask = (filterstring c.name "|")[2] as number
								local task = lTasks[nTask]
								
								case tAction of
								(
									"clean":
									(
										tooltip = dotnetobject "System.Windows.Forms.ToolTip"
										tooltip.SetToolTip c task.tTooltip
										tooltip.Active = True 
										tooltip.isballoon = True
										tooltip.InitialDelay = 2000
										
										local tCleanCode = ""
										tCleanCode += "fn f sender e =(\n"
										--tCleanCode += "print \"Cleaning "+ nTask as string +": "+ c.text +"\"\n"
										tCleanCode += "try(\n"
										tCleanCode += "cCleaner.lTasks["+ nTask as string +"].clean()\n"
										tCleanCode += "nCount = cCleaner.lTasks["+ nTask as string +"].count()\n"
										tCleanCode += "cCleaner.lCountButtons["+ nTask as string +"].backcolor = (dotnetclass \"system.drawing.color\").FromArgb 240 240 240\n"
										tCleanCode += "if classof nCount == integer then cCleaner.lCountButtons["+ nTask as string +"].text = nCount as string\n"
										tCleanCode += ")catch(print (\""+ task.tName +"\"+ getcurrentexception())))\n"
										lCleanFunctions[nTask] = (execute tCleanCode)
										dotnet.addeventhandler c "click" lCleanFunctions[nTask]
									)
									
									"count":
									(
										local tCountCode = ""
										tCountCode += "fn f sender e =(\n"
										--tCleanCode += "print \"Counting "+ nTask as string +": "+ c.text +"\"\n"
										tCountCode += "try(\n"
										tCountCode += "nCount = cCleaner.lTasks["+ nTask as string +"].count()\n"
										tCountCode += "if classof nCount == integer then"
										tCountCode += "(\n"
										tCountCode += "cCleaner.lCountButtons["+ nTask as string +"].text = nCount as string\n"
										tCountCode += "if nCount > 0 then cCleaner.lCountButtons["+ nTask as string +"].backcolor = (dotnetclass \"system.drawing.color\").FromArgb 245 245 168\n"
										tCountCode += ")\n"
										tCountCode += ")catch(print (\""+ task.tName +"\"+ getcurrentexception())))\n"
										
										if not task.enabled then tCountCode += "fn f sender e =()\n"
										
										lCountFunctions[nTask] = (execute tCountCode)
										lCountButtons[nTask] = c
										dotnet.addeventhandler c "click" lCountFunctions[nTask]
									)
									
									"select objects":
									(
										tooltip = dotnetobject "System.Windows.Forms.ToolTip"
										tooltip.SetToolTip c "Select affected Objects"
										tooltip.Active = True 
										tooltip.isballoon = True
										tooltip.InitialDelay = 2000
										
										local tSelObjsCode = ""
										tSelObjsCode += "fn f sender e =\n"
										tSelObjsCode += "try(\n"
										tSelObjsCode += "cCleaner.lTasks["+ nTask as string +"].selectObjects()\n"
										tSelObjsCode += ")catch(print (\""+ task.tName +"\"+ getcurrentexception()))\n"
										lSelectObjectsFunctions[nTask] = (execute tSelObjsCode)
										dotnet.addeventhandler c "click" lSelectObjectsFunctions[nTask]
									)
									
									"select materials":
									(
										tooltip = dotnetobject "System.Windows.Forms.ToolTip"
										tooltip.SetToolTip c "Send affected Materials to Materialeditor"
										tooltip.Active = True 
										tooltip.isballoon = True
										tooltip.InitialDelay = 2000
										
										dotnet.addeventhandler c "click" (execute ("fn f = try cCleaner.lTasks["+ nTask as string +"].selectMaterials() catch(print (\""+ task.tName +"\"+ getcurrentexception()))"))
									)
									
									default: ()
								)
								
								dotNet.setLifetimeControl c #dotNet
							)
						)
					
					-- update
						
						local nRolloutH = cPanel.controls.item[nGroup-1].location.y + nMaxY + 8
						local primScreenSize = [(dotNetClass "System.Windows.Forms.Screen").PrimaryScreen.Bounds.width, (dotNetClass "System.Windows.Forms.Screen").PrimaryScreen.Bounds.height]
						
						if nRolloutH > sysInfo.desktopSize.y - 200 then nRolloutH = sysInfo.desktopSize.y - 200
						cCleaner.height = nRolloutH+20
						
						setdialogpos cCleaner [primScreenSize.x/2-cCleaner.width/2, primScreenSize.y/2-cCleaner.height/2]
					
					-- count thread
						
						CountThread = dotnetobject "CSharpUtilities.SynchronizingBackgroundWorker"
						CountThread.WorkerSupportsCancellation = true		
						dotNet.addEventHandler CountThread "DoWork" cCleaner.CountThreadFn
						
						if not CountThread.IsBusy do CountThread.RunWorkerAsync()	
				)
				
				Fn CountThreadFn sender e =
				(					
					for n=1 to cCleaner.lCountFunctions.count do
					(
						if lCountFunctions[n] != undefined then cCleaner.lCountFunctions[n] undefined undefined
						
						local c = cCleaner.lCountButtons[n]
						if c.text == "" then c.visible = false
						else if c.text as number > 0 then c.backcolor = (dotnetclass "system.drawing.color").FromArgb 245 245 168
						
						local nProgress = (n as float / cCleaner.lCountFunctions.count * 100) as integer
						cCleaner.title = if nProgress < 100
							then cCleaner.tScriptTitle +" ... loading "+ nProgress as string +"%"
							else cCleaner.tScriptTitle
					)
					
					if cCleaner.bStartup then
					(
						-- unlock controls
							
							try
							(
								for nGroup=1 to cPanel.controls.count do
								(
									local cGroup = cPanel.controls.item (nGroup-1)
									for nGroupControl=1 to cGroup.controls.count do
									(
										local c = cGroup.controls.item (nGroupControl-1)
										local tAction = (filterstring c.name "|")[1]
										local nTask = (filterstring c.name "|")[2] as number
										local task = lTasks[nTask]
										c.enabled = task.enabled
									)
								)
							)
							catch()
					)
					
					cCleaner.bStartup = false
				)
			
			-- EVENTS
				
				on cCleaner resized size do
				(
					cPanel.height = cCleaner.height - cPanel.pos.y
				)
		)
		
		cCleaner.openDialog()
	)
)